package com.jcg.section7;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
//Example-7.1: CompletableFuture taking Supplier as input - cancel demo
public class CompletableExample1 {
    
    public static void main(String[] args){
        System.out.println("Initiating Main:  " + Thread.currentThread().getName());
        
        CompletableFuture<String> completable
         = CompletableFuture.supplyAsync(new SampleSupplier());
        try{        
        String result = completable.get(2,TimeUnit.SECONDS);
        }catch(Exception ex){
            
            System.out.println("Exception " + ex);
            completable.cancel(true);      
        }
        System.out.println("Completing Main:  " + Thread.currentThread().getName());
    }   
}
