package com.jcg.section7;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
//Example-7.1: CompletableFuture taking Supplier as input - blocking get() method
public class CompletableExample2 {
    
    public static void main(String[] args){
        System.out.println("Initiating Main:  " + Thread.currentThread().getName());
        String result = null;
        CompletableFuture<String> completable
         = CompletableFuture.supplyAsync(new SampleSupplier());
        try{        
          result = completable.get();
        }catch(Exception ex){
            System.out.println("Exception " + ex);
            completable.cancel(true);
        }
        System.out.println("Result is " + result);
        System.out.println("Completing Main:  " + Thread.currentThread().getName());
    }   
}
