package com.jcg.section8;

import java.time.LocalTime;
import java.util.concurrent.Callable;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
public class CallableForScheduling implements Callable 
{
    Integer callID;
    
    public CallableForScheduling(int callID){
        this.callID = callID;
    }
    
    @Override
    public Integer call() throws Exception {
        String threadName = Thread.currentThread().getName();
        System.out.println("Initiating call() @ " + threadName+ " @ "  + LocalTime.now());
        TimeUnit.SECONDS.sleep(2);
        System.out.println("Completing call() @ " + threadName + " @ " +LocalTime.now());
        return callID;
    }

}
