package com.jcg.section8;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
public class ScheduledExample1 {
    public static void main(String[] args){
        ScheduledExample1 app = new ScheduledExample1();
        try {
        app.test();
        } catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    public void test() throws Exception
    {
        ScheduledExecutorService executor = Executors.newSingleThreadScheduledExecutor();
        ScheduledFuture<?> schedFuture = executor.schedule(new CallableForScheduling(5), 2, TimeUnit.SECONDS);
        
        System.out.println(schedFuture.get());
        executor.shutdown();
        
    }

}
