package com.jcg.section7;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
public class CompletableExample {
    
    public static void main(String[] args){
        System.out.println("Initiating Main:  " + Thread.currentThread().getName());
        
        CompletableFuture<Void> completable
         = CompletableFuture.runAsync(new Runnable(){
            
            @Override
            public void run(){
                System.out.println("Start of runnable " + Thread.currentThread().getName());
                try{
                    TimeUnit.SECONDS.sleep(5);
                } catch(InterruptedException iex){
                    iex.printStackTrace();
                }
                System.out.println("End of runnable " + Thread.currentThread().getName());
            }
        });
        
        System.out.println("Completing Main:  " + Thread.currentThread().getName());
    }
}
